"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantFileMetadata(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_9 import opencb as opencb_1_3_0

        return {
            "header": opencb_1_3_0.VariantFileHeader,
            "stats": opencb_1_3_0.VariantSetStats,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_9 import opencb as opencb_1_3_0

        return {
            "org.opencb.biodata.models.variant.metadata.VariantFileHeader": opencb_1_3_0.VariantFileHeader,
            "org.opencb.biodata.models.variant.metadata.VariantSetStats": opencb_1_3_0.VariantSetStats,
            "org.opencb.biodata.models.variant.metadata.VariantFileMetadata": opencb_1_3_0.VariantFileMetadata,
        }

    __slots__ = [
        "id",
        "attributes",
        "header",
        "path",
        "sampleIds",
        "stats",
    ]

    def __init__(
        self,
        id,
        attributes=dict,
        header=None,
        path=None,
        sampleIds=list,
        stats=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_1_3_0.VariantFileMetadata model.

        :param id:
            File id. Will match with the {@link
            org.opencb.biodata.models.variant.avro.FileEntry#getFileId}
        :type id: str
        :param attributes:
            Other user defined attributes related with the file
        :type attributes: dict[str, str]
        :param header:
            The Variant File Header
        :type header: None | VariantFileHeader
        :param path:
            Path to the original file
        :type path: None | str
        :param sampleIds:
            Ordered list of sample ids contained in the file
        :type sampleIds: list[str]
        :param stats:
            Global statistics calculated for this file
        :type stats: None | VariantSetStats
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
